"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VirtualPanel(ProtocolElement):
    """
    This record defines a gene panel.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "geneIds",
        "panelName",
        "panelVersion",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "clinicalRelevantVariants": reports_2_1_0.File,
            "relevantRegions": reports_2_1_0.File,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.VirtualPanel": reports_2_1_0.VirtualPanel,
        }

    __slots__ = [
        "geneIds",
        "panelName",
        "panelVersion",
        "Transcripts",
        "clinicalRelevantVariants",
        "dataModelCatalogueVersion",
        "ensemblVersion",
        "relevantRegions",
    ]

    def __init__(
        self,
        geneIds,
        panelName,
        panelVersion,
        Transcripts=None,
        clinicalRelevantVariants=None,
        dataModelCatalogueVersion="4.2",
        ensemblVersion=None,
        relevantRegions=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.VirtualPanel model.

        :param geneIds:
            gene id from ensembl (version as per annotation file)
        :type geneIds: list[str]
        :param panelName:
            Name of the Panel
        :type panelName: str
        :param panelVersion:
            Version of the Gene Panel
        :type panelVersion: str
        :param Transcripts:
            transcript ids from ensembl
        :type Transcripts: None | list[str]
        :param clinicalRelevantVariants:
            VCF File
        :type clinicalRelevantVariants: None | File
        :param dataModelCatalogueVersion:
            Version of the Data Catalogue against which the information is being
            provided     The data catalogue version should internally
            keep track of the version for the HPO ontology
        :type dataModelCatalogueVersion: str
        :param ensemblVersion:
            Ensembl version used to get teh genes or transcripts
        :type ensemblVersion: None | str
        :param relevantRegions:
            BED format file
        :type relevantRegions: None | File
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
